HDU 4081 Qin Shi Huang's National Road System(最小生成树+暴力枚举边)

题目大意:给你1000个点,每个点上有一个数目代表这个城市有多少人,让你把这N个点构成一颗生成树,你可以删除其中的任意一条边。让你求出一个比例A/B是的这个比例最大,A表示你删除那条边上两个城市的人口数之和,B表示的是去掉这条变这可生成树上其他的边的总长度。

解体思路:先求出来最小生成树,然后暴力枚举生成树的边,B=总数-这条边的长度。A = 将这条连断开之后左右集合中权值最大的两个数的和。

这样保证了B最小的情况下,去找最大的A,所以是可行的解。生成树的同时建边,然后dfs找最大值。

PS:这题C++超时,G++AC了啊。

Qin Shi Huang's National Road System

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 3912    Accepted Submission(s): 1351


Problem Description
During the Warring States Period of ancient China(476 BC to 221 BC), there were seven kingdoms in China ---- they were Qi, Chu, Yan, Han, Zhao, Wei and Qin. Ying Zheng was the king of the kingdom Qin. Through 9 years of wars, he finally conquered all six other kingdoms and became the first emperor of a unified China in 221 BC. That was Qin dynasty ---- the first imperial dynasty of China(not to be confused with the Qing Dynasty, the last dynasty of China). So Ying Zheng named himself "Qin Shi Huang" because "Shi Huang" means "the first emperor" in Chinese.

Qin Shi Huang undertook gigantic projects, including the first version of the Great Wall of China, the now famous city-sized mausoleum guarded by a life-sized Terracotta Army, and a massive national road system. There is a story about the road system:
There were n cities in China and Qin Shi Huang wanted them all be connected by n-1 roads, in order that he could go to every city from the capital city Xianyang.
Although Qin Shi Huang was a tyrant, he wanted the total length of all roads to be minimum,so that the road system may not cost too many people's life. A daoshi (some kind of monk) named Xu Fu told Qin Shi Huang that he could build a road by magic and that magic road would cost no money and no labor. But Xu Fu could only build ONE magic road for Qin Shi Huang. So Qin Shi Huang had to decide where to build the magic road. Qin Shi Huang wanted the total length of all none magic roads to be as small as possible, but Xu Fu wanted the magic road to benefit as many people as possible ---- So Qin Shi Huang decided that the value of A/B (the ratio of A to B) must be the maximum, which A is the total population of the two cites connected by the magic road, and B is the total length of none magic roads.
Would you help Qin Shi Huang?
A city can be considered as a point, and a road can be considered as a line segment connecting two points.
 

Input
The first line contains an integer t meaning that there are t test cases(t <= 10).
For each test case:
The first line is an integer n meaning that there are n cities(2 < n <= 1000).
Then n lines follow. Each line contains three integers X, Y and P ( 0 <= X, Y <= 1000, 0 < P < 100000). (X, Y) is the coordinate of a city and P is the population of that city.
It is guaranteed that each city has a distinct location.
 

Output
For each test case, print a line indicating the above mentioned maximum ratio A/B. The result should be rounded to 2 digits after decimal point.
 

Sample Input
  
  
2 4 1 1 20 1 2 30 200 2 80 200 1 100 3 1 1 20 1 2 30 2 2 40
 

Sample Output
  
  
65.00 70.00
 

Source
 

#include <algorithm>
#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <iomanip>
#include <stdio.h>
#include <string>
#include <queue>
#include <cmath>
#include <time.h>
#include <stack>
#include <map>
#include <set>
#define eps 1e-8
#define M 1000100
///#define LL long long
#define LL __int64
#define INF 0x3f3f3f
#define PI 3.1415926535898


using namespace std;

const int maxn = 1010;

struct node
{
    double x, y;
    double num;
} f[maxn];

int cnt;

vector<int> g[maxn];

int fa[maxn];

int head[maxn*maxn];

struct nod
{
    int u, v;
    double w;
    int next;
} p[maxn*maxn];


struct sx
{
    int x, y;
    double dis;
} px[maxn];

int vis[maxn];

double Max1, Max2;
double Smax;

int Find(int x)
{
    if(x != fa[x]) fa[x] = Find(fa[x]);
    return fa[x];
}

bool cmp(nod a, nod b)
{
    return a.w < b.w;
}

void init(int n)
{
    cnt = 0;
    for(int i = 0; i <= n; i++)
    {
        fa[i] = i;
        head[i] = -1;
        g[i].clear();
    }
}

double dis(node a, node b)
{
    return sqrt((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));
}


void add(int u, int v, double w)
{
    p[cnt].u = u;
    p[cnt].v = v;
    p[cnt].w = w;
    p[cnt].next = head[u];
    head[u] = cnt++;
    p[cnt].v = u;
    p[cnt].u = v;
    p[cnt].w = w;
    p[cnt].next = head[v];
    head[v] = cnt++;
}

void dfs(int x, int fa)
{
    Smax = max(Smax, f[x].num);
    for(int i = 0; i < g[x].size(); i++)
    {
        int sx = g[x][i];
        if(sx == fa) continue;
        dfs(sx, x);
    }
}

int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        int n;
        scanf("%d",&n);
        init(n);
        for(int i = 1; i <= n; i++) scanf("%lf %lf %lf",&f[i].x, &f[i].y, &f[i].num);
        for(int i = 1; i <= n; i++)
        {
            for(int j = i+1; j <= n; j++)
            {
                double xdis = dis(f[i], f[j]);
                add(i, j, xdis);
            }
        }
        sort(p, p+cnt, cmp);
        double sum = 0;
        int xans = 0;
        for(int i = 0; i < cnt; i++)
        {
            int x = p[i].u;
            int y = p[i].v;
            int fau = Find(p[i].u);
            int fav = Find(p[i].v);
            if(fav != fau)
            {
                fa[fau] = fav;
                sum += p[i].w;
                px[xans].x = x;
                px[xans].y = y;
                px[xans++].dis = p[i].w;
                g[x].push_back(y);
                g[y].push_back(x);
            }
        }
        double Max = 0;
        for(int i = 0; i < xans; i++)
        {
            int x = px[i].x;
            int y = px[i].y;
            Smax = 0;
            dfs(x, y);
            Max1 = Smax;
            Smax = 0;
            dfs(y, x);
            Max2 = Smax;
            Max = max(Max, (Max1+Max2)/(sum-px[i].dis));
        }
        printf("%.2lf\n",Max);
    }
    return 0;
}


  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值